package jp.gr.java_conf.abagames.pavg;

import java.io.*;

/**
 * Parse the stream of CSV format characters into tokens
 */
public class CSVStreamTokenizer {
  Reader reader;

  public CSVStreamTokenizer(Reader reader) {
    this.reader = reader;
  }

  private boolean separatedByLineSeparator;

  private boolean separated = false;
  private boolean quoted = false;
  private boolean quoteend = false;

  public String nextToken() throws IOException {
    StringBuffer result = new StringBuffer();
    for ( ; ; ) {
      int ch = reader.read();
      if ( ch == -1 ) {
        String rslStr = new String(result).trim();
        separatedByLineSeparator = false;
        if ( rslStr.length() <= 0 ) return null;
        else return rslStr;
      } else if ( ch == ',' && !quoted ) {
        separated = false;
        quoteend = false;
        separatedByLineSeparator = false;
        return new String(result);
      } else if ( ch == '\n' || ch == '\r' ) {
        if ( separated ) continue;
        if  ( quoted ) {
          separated = true;
          result.append((char)'\n');
        } else {
          separated = true;
          quoteend = false;
          separatedByLineSeparator = true;
          return new String(result);
        }
      } else if ( ch == '"' || ch == '\'' ) {
        separated = false;
        if ( quoted ) {
          quoted = false;
          quoteend = true;
        } else if ( quoteend ) {
          quoted = true;
          quoteend = false;
          result.append((char)ch);
        } else {
          quoted = true;
          quoteend = false;
        }
      } else {
        separated = false;
        quoteend = false;
        result.append((char)ch);
      }
    }
  }

  public boolean isSeparatedByLineSeparator() {
    return separatedByLineSeparator;
  }
}
