/**
 * Palm Adventure
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * pavg.h(header file)
 */
#include "pavg_rsc.h"

#define PAVG_CID 'PAVG'
#define PAVG_VER 102

#define TRUE 1
#define FALSE 0

#define TITLE_LENGTH 50
#define COPYRIGHT_LENGTH 34
#define MESSAGE_LENGTH 194
#define CHOICES_LENGTH 34

typedef struct {
  char msg[CHOICES_LENGTH];
  int nextIndex;
} Choices;

#define CHOICES_NUM 4

typedef struct {
  int index;
  char msg[MESSAGE_LENGTH];
  Choices choices[CHOICES_NUM];
} Item;

typedef struct {
  char title[TITLE_LENGTH];
  char copyright[COPYRIGHT_LENGTH];
  Item item[1];
} Scenario;

typedef struct {
  char name[35];
  UInt16 cardNo;
} ScenarioDatabase;

typedef struct {
  int itemIndex;
  int bookmark;
  ScenarioDatabase scenarioDatabase;
} GameStatus;
